unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ClassFalling, ClassFallingSlice, ClassDefinitions,
  ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    Button3: TButton;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Button4: TButton;
    Button5: TButton;
    Label1: TLabel;
    TrackBar1: TTrackBar;
    Label2: TLabel;
    TrackBar2: TTrackBar;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
  private
    FBitmap: TBitmap;
    FFalling: TFalling;
    FStop: Boolean;
    procedure PaintCurrentState;
    procedure OnAllFull(Sender: TObject);
  public
    procedure PrintDebug(Msg: String); overload;
    procedure PrintDebug(Msg: String; Params: array of const); overload;
  end;


var
  Form1: TForm1;

implementation

{$R *.dfm}


{ TForm1}

const
  SNOW_WIDTH    = 4; // e(pixel)
  SNOW_HEIGHT   = 2; // ᰪ(pixel)

{==============================================================================}
{   إ߮                                                                 }
{==============================================================================}
procedure TForm1.FormCreate(Sender: TObject);
const
  SLICE_COUNT = 50;
  SLICE_HEIGHT = 100;
var
  i:    Integer;
  fs:   TFallingSlice;
begin
  FBitmap := TBitmap.Create;
  FBitmap.PixelFormat := pf24bit;
  // إ߳ᱱ, ä@@إ߳W[J䤤
  FFalling := TFalling.Create;
  FFalling.OnAllFull := OnAllFull;
  for i:=1 to SLICE_COUNT do
  begin
    fs := TFallingSlice.Create(SLICE_HEIGHT);
    fs.ID := i;
    fs.OnLog := PrintDebug;
    FFalling.Add(fs);
  end;
  // lƧ@eΪBitmap
  FBitmap.Width := SNOW_WIDTH * FFalling.Count;
  FBitmap.Height := SNOW_HEIGHT * FFalling.Items[0].Capacity;
  FBitmap.Canvas.Brush.Color := clBlack;
  FBitmap.Canvas.FillRect(FBitmap.Canvas.ClipRect);
end;

{==============================================================================}
{   Ѻc                                                                 }
{==============================================================================}
procedure TForm1.FormDestroy(Sender: TObject);
begin
  FFalling.Free;
  FBitmap.Free;
end;

{==============================================================================}
{   eXثeA                                                               }
{==============================================================================}
procedure TForm1.PaintCurrentState;
var
  p,
  t,
  k,
  i:    Integer;
  pHi,
  pLo:  PRGBTriple;
begin
  if (FFalling.Count = 0) then Exit;

  t := FFalling.Items[0].Capacity-1;
  for i:=t downto 0 do // ѤWUeXC@C
  begin
    pHi := FBitmap.ScanLine[(t-i)*SNOW_HEIGHT];
    pLo := FBitmap.ScanLine[(t-i)*SNOW_HEIGHT+1];
    for k:=0 to FFalling.Count-1 do // ѥkeXC@C
    begin
      if FFalling.Items[k].Items[i] = SNOW then
      begin
        // e
        for p:=1 to SNOW_WIDTH do
        begin
          if (p = SNOW_WIDTH) then // j
          begin
            pHi.rgbtRed := 16; pHi.rgbtGreen := 16; pHi.rgbtBlue := 16;
          end
          else
          begin
            pHi.rgbtRed := 255; pHi.rgbtGreen := 255; pHi.rgbtBlue := 255;
          end;
          Inc(pHi);
        end;
        for p:=1 to SNOW_WIDTH do
        begin
          if (p = SNOW_WIDTH) then // j
          begin
            pLo.rgbtRed := 16; pLo.rgbtGreen := 16; pLo.rgbtBlue := 16;
          end
          else
          begin
            pLo.rgbtRed := 0; pLo.rgbtGreen := 0; pLo.rgbtBlue := 64;
          end;
          Inc(pLo);
        end;
      end
      else
      begin
        // eѪ
        for p:=1 to SNOW_WIDTH do
        begin
          if (p = SNOW_WIDTH) then // j
          begin
            pHi.rgbtRed := 16; pHi.rgbtGreen := 16; pHi.rgbtBlue := 16;
          end
          else
          begin
            pHi.rgbtRed := 64; pHi.rgbtGreen := 64; pHi.rgbtBlue := 64;
          end;
          Inc(pHi);
        end;
        for p:=1 to SNOW_WIDTH do
        begin
          if (p = SNOW_WIDTH) then // j
          begin
            pLo.rgbtRed := 16; pLo.rgbtGreen := 16; pLo.rgbtBlue := 16;
          end
          else
          begin
            pLo.rgbtRed := 0; pLo.rgbtGreen := 0; pLo.rgbtBlue := 64;
          end;
          Inc(pLo);
        end;
      end;
    end;
  end;
  Label1.Canvas.Draw(5, 5, FBitmap);
end;

{==============================================================================}
{   UStep                                                                   }
{==============================================================================}
procedure TForm1.Button1Click(Sender: TObject);
begin
  if not FFalling.IsAllFull then
  begin
    FFalling.FallingStep;
    PaintCurrentState;
  end;
end;

{==============================================================================}
{   UClear                                                                  }
{==============================================================================}
procedure TForm1.Button2Click(Sender: TObject);
begin
  FFalling.Reset;
  PaintCurrentState;
  Memo1.Clear;
end;

{==============================================================================}
{   bMemoXT                                                           }
{==============================================================================}
procedure TForm1.PrintDebug(Msg: String);
begin
  Memo1.Lines.Add(Msg);
end;

procedure TForm1.PrintDebug(Msg: String; Params: array of const);
var
  s: String;
begin
  try
    s := Format(Msg, Params);
    PrintDebug(s);
  except
    PrintDebug('<!>Format Error');
  end;
end;

{==============================================================================}
{   UDump All                                                               }
{==============================================================================}
procedure TForm1.Button3Click(Sender: TObject);
begin
  // LXثeFalling󪺤e
  Memo1.Lines.BeginUpdate;
  try
    FFalling.Dump;
  finally
    Memo1.Lines.EndUpdate;
  end;
end;

{==============================================================================}
{   Falling󤺪WF                                              }
{==============================================================================}
procedure TForm1.OnAllFull(Sender: TObject);
begin
  PrintDebug('All Full');
end;

{==============================================================================}
{   ULoop                                                                   }
{==============================================================================}
procedure TForm1.Button4Click(Sender: TObject);
begin
  // 򱼸
  FStop := False;
  Button1.Enabled := False;
  Button2.Enabled := False;
  Button3.Enabled := False;
  Button4.Enabled := False;
  while not FFalling.IsAllFull do
  begin
    FFalling.FallingStep;
    PaintCurrentState;
    Sleep(10*TrackBar1.Position);
    Application.ProcessMessages;
    if FStop then break;
  end;
  Button1.Enabled := True;
  Button2.Enabled := True;
  Button3.Enabled := True;
  Button4.Enabled := True;
end;

{==============================================================================}
{   UStop                                                                   }
{==============================================================================}
procedure TForm1.Button5Click(Sender: TObject);
begin
  FStop := True;
end;


procedure TForm1.TrackBar2Change(Sender: TObject);
begin
  FFalling.Frequency := TrackBar2.Position;
end;

initialization
  Randomize;

end.
